/**
 * Wrapper for Worlize WebSocketNode to emulate the browser WebSocket object.
 */
var WebSocketClient = require('./WorlizeWebSocketNode/lib/websocket').client;

exports.WebSocket = function (uri) {
  var self = this;
  this.connection = null;
  this.socket = new WebSocketClient();
  this.socket.on('connect', function (connection) {
    self.connection = connection;
    
    connection.on('error', function (error) {
      if (self.onerror) {
        self.onerror();
      }
    });
    
    connection.on('close', function () {
      if (self.onclose) {
        self.onclose();
      }
    });
  
    connection.on('message', function (message) {
      if (message.type === 'utf8') {
        if (self.onmessage) {
          self.onmessage({data:message.utf8Data});
        }
      }
    });
    
    if (self.onopen) {
      self.onopen();
    }
  });
  this.socket.connect(uri);
}

exports.WebSocket.prototype.send = function (data) {
  this.connection.sendUTF(data);
}
